# list of all qospf nodes
RtModule/QOSPF set qospf_nodes_ ""

Simulator instproc configure-qospf-nodes {} {
    RtModule/QOSPF instvar qospf_nodes_
    #puts "in Simulator instproc configure-qospf-nodes"

    
    # 1. create qospf agents on all qospf nodes
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	$rtnode make-qospf-agent
    }

    # 1. set no. of nodes for use in MessageCenter

    if { [llength $qospf_nodes_] == 0 } {
	return
    }

    set node [lindex $qospf_nodes_ 0]
    set rt [$node get-module QOSPF]
    set qagent [$rt set qospf_agent_]
    $qagent cmd setNodeNumber [llength $qospf_nodes_]

    # 2. fill peers_
    # 3. call initaialize
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	set qagentnode [$rtnode set qospf_agent_]
	$qagentnode instvar peers_
	foreach nbr [$node neighbors] {
	    set rtnbr [$nbr get-module QOSPF]
	    if { $rtnbr == "" } {
		continue
	    }
	    lappend peers_ $nbr
	}
	
	$qagentnode cmd initialize
    }
}

Simulator instproc configure-perd-qospf-nodes {} {
    RtModule/QOSPF instvar qospf_nodes_
    #puts "in Simulator instproc configure-qospf-nodes"

    
    # 1. create qospf agents on all qospf nodes
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	$rtnode make-ef-qospf-agent
	$rtnode make-af1-qospf-agent
	$rtnode make-af2-qospf-agent
	$rtnode make-af3-qospf-agent
	$rtnode make-af4-qospf-agent
	$rtnode make-be-qospf-agent
    }

    # 1. set no. of nodes for use in MessageCenter

    if { [llength $qospf_nodes_] == 0 } {
	return
    }

    # For EF Agent

    set node [lindex $qospf_nodes_ 0]
    set rt [$node get-module QOSPF]
    set efqagent [$rt set efqospf_agent_]
    #puts "efagent=$efqagent"
    $efqagent cmd setNodeNumber [llength $qospf_nodes_]

    # 2. fill peers_
    # 3. call initaialize
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	set efqagentnode [$rtnode set efqospf_agent_]
	$efqagentnode instvar peers_
	foreach nbr [$node neighbors] {
	    set rtnbr [$nbr get-module QOSPF]
	    if { $rtnbr == "" } {
		continue
	    }
	    lappend peers_ $nbr
	}
	$efqagentnode cmd initialize
    }

    # For AF1 Agent
    set node [lindex $qospf_nodes_ 0]
    set rt [$node get-module QOSPF]
    set af1qagent [$rt set af1qospf_agent_]
    #puts "af1agent=$af1qagent"
    $af1qagent cmd setNodeNumber [llength $qospf_nodes_]

    # 2. fill peers_
    # 3. call initaialize
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	set af1qagentnode [$rtnode set af1qospf_agent_]
	$af1qagentnode instvar peers_
	foreach nbr [$node neighbors] {
	    set rtnbr [$nbr get-module QOSPF]
	    if { $rtnbr == "" } {
		continue
	    }
	    lappend peers_ $nbr
	}
	$af1qagentnode cmd initialize
    }

    # For AF2 Agent
    set node [lindex $qospf_nodes_ 0]
    set rt [$node get-module QOSPF]
    set af2qagent [$rt set af2qospf_agent_]
    #puts "af2agent=$af2qagent"
    $af2qagent cmd setNodeNumber [llength $qospf_nodes_]

    # 2. fill peers_
    # 3. call initaialize
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	set af2qagentnode [$rtnode set af2qospf_agent_]
	$af2qagentnode instvar peers_
	foreach nbr [$node neighbors] {
	    set rtnbr [$nbr get-module QOSPF]
	    if { $rtnbr == "" } {
		continue
	    }
	    lappend peers_ $nbr
	}
	$af2qagentnode cmd initialize
    }

    # For AF3 Agent
    set node [lindex $qospf_nodes_ 0]
    set rt [$node get-module QOSPF]
    set af3qagent [$rt set af3qospf_agent_]
    #puts "af3agent=$af3qagent"
    $af3qagent cmd setNodeNumber [llength $qospf_nodes_]

    # 2. fill peers_
    # 3. call initaialize
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	set af3qagentnode [$rtnode set af3qospf_agent_]
	$af3qagentnode instvar peers_
	foreach nbr [$node neighbors] {
	    set rtnbr [$nbr get-module QOSPF]
	    if { $rtnbr == "" } {
		continue
	    }
	    lappend peers_ $nbr
	}
	$af3qagentnode cmd initialize
    }

    # For AF4 Agent
    set node [lindex $qospf_nodes_ 0]
    set rt [$node get-module QOSPF]
    set af4qagent [$rt set af4qospf_agent_]
    #puts "af4agent=$af4qagent"
    $af4qagent cmd setNodeNumber [llength $qospf_nodes_]

    # 2. fill peers_
    # 3. call initaialize
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	set af4qagentnode [$rtnode set af4qospf_agent_]
	$af4qagentnode instvar peers_
	foreach nbr [$node neighbors] {
	    set rtnbr [$nbr get-module QOSPF]
	    if { $rtnbr == "" } {
		continue
	    }
	    lappend peers_ $nbr
	}
	$af4qagentnode cmd initialize
    }

    # For BE Agent
    set node [lindex $qospf_nodes_ 0]
    set rt [$node get-module QOSPF]
    set beqagent [$rt set beqospf_agent_]
    #puts "beagent=$beqagent"
    $beqagent cmd setNodeNumber [llength $qospf_nodes_]

    # 2. fill peers_
    # 3. call initaialize
    foreach node $qospf_nodes_ {
	set rtnode [$node get-module QOSPF]
	set beqagentnode [$rtnode set beqospf_agent_]
	$beqagentnode instvar peers_
	foreach nbr [$node neighbors] {
	    set rtnbr [$nbr get-module QOSPF]
	    if { $rtnbr == "" } {
		continue
	    }
	    lappend peers_ $nbr
	}
	$beqagentnode cmd initialize
    }
}

RtModule/QOSPF instproc register { node } {
    $self instvar classifier_ qospf_agent_ efqospf_agent_ af1qospf_agent_ af2qospf_agent_ af3qospf_agent_ af4qospf_agent_  beqospf_agent_ node_ 
    $class instvar qospf_nodes_

    #puts "in RtModule/QOSPF instproc register: node = $node, self = $self"

    $self set node_ $node

    #append node to qospf_nodes_
    lappend qospf_nodes_ $node
     
    #$self set classifier_ [$node entry]

    #$self set qospf_agent_ [new Agent/QOSPF $node]

    $node unreg-port-notify $self

    $self attach-node $node

    #debug 1
    #$node attach $qospf_agent_

}

RtModule/QOSPF instproc make-qospf-agent {} {
    $self instvar qospf_agent_ node_
    $self set qospf_agent_ [new Agent/QOSPF]
    #puts $node_
    $node_ attach $qospf_agent_
}

RtModule/QOSPF instproc make-ef-qospf-agent {} {
    $self instvar efqospf_agent_ node_
    $self set efqospf_agent_ [new Agent/QOSPF "EF"]
    #puts $node_
    #puts "*********efagent=$efqagent"
    $node_ attach $efqospf_agent_
}

RtModule/QOSPF instproc make-af1-qospf-agent {} {
    $self instvar af1qospf_agent_ node_
    $self set af1qospf_agent_ [new Agent/QOSPF "AF1"]
    #puts $node_
    #puts "*********af1agent=$af1qagent"
    $node_ attach $af1qospf_agent_
}

RtModule/QOSPF instproc make-af2-qospf-agent {} {
    $self instvar af2qospf_agent_ node_
    $self set af2qospf_agent_ [new Agent/QOSPF "AF2"]
    #puts $node_
    #puts "*********af2agent=$af2qagent"
    $node_ attach $af2qospf_agent_
}

RtModule/QOSPF instproc make-af3-qospf-agent {} {
    $self instvar af3qospf_agent_ node_
    $self set af3qospf_agent_ [new Agent/QOSPF "AF3"]
    #puts $node_
    #puts "*********af3agent=$af3qagent"
    $node_ attach $af3qospf_agent_
}

RtModule/QOSPF instproc make-af4-qospf-agent {} {
    $self instvar af4qospf_agent_ node_
    $self set af4qospf_agent_ [new Agent/QOSPF "AF4"]
    #puts $node_
    #puts "*********af4agent=$af4qagent"
    $node_ attach $af4qospf_agent_
}

RtModule/QOSPF instproc make-be-qospf-agent {} {
    $self instvar beqospf_agent_ node_
    $self set beqospf_agent_ [new Agent/QOSPF "BE"]
    #puts $node_
    #puts "*********beagent=$beqagent"
    $node_ attach $beqospf_agent_
}

RtModule/QOSPF instproc intf-changed {} {
    $self instvar qospf_agent_ efqospf_agent_ af1qospf_agent_ af2qospf_agent_ af3qospf_agent_ af4qospf_agent_  beqospf_agent_
    #puts "in RtModule/QOSPF instproc intf-changed"
    if {![info exists qospf_agent_]} {
    $efqospf_agent_ intf-changed
    $af1qospf_agent_ intf-changed
    $af2qospf_agent_ intf-changed
    $af3qospf_agent_ intf-changed
    $af4qospf_agent_ intf-changed
    $beqospf_agent_ intf-changed
    } else {
    $qospf_agent_ intf-changed
    }
}

RtModule/QOSPF instproc get-explicit-route {dest bw} {
    $self instvar qospf_agent_
    #puts "in RtModule/QOSPF instproc get-explicit-route: dest = $dest, bw = $bw"
    set eroute [$qospf_agent_ get-explicit-route $dest $bw]
    return $eroute
}

RtModule/QOSPF instproc bw-changed {} {
    $self instvar qospf_agent_
    #puts "in RtModule/QOSPF instproc bw-changed"
    $qospf_agent_ bw-changed
}

RtModule/QOSPF instproc get-perd-explicit-route {dest bw traffic} {
    $self instvar efqospf_agent_ af1qospf_agent_ af2qospf_agent_ af3qospf_agent_ af4qospf_agent_ beqospf_agent_
    #puts "in RtModule/QOSPF instproc get-explicit-route: dest = $dest, bw = $bw"
    if {$traffic=="EF"} {
    set eroute [$efqospf_agent_ get-explicit-route $dest $bw]
    } elseif {$traffic=="AF1"} {
    set eroute [$af1qospf_agent_ get-explicit-route $dest $bw]
    } elseif {$traffic=="AF2"} {
    set eroute [$af2qospf_agent_ get-explicit-route $dest $bw]
    } elseif {$traffic=="AF3"} {
    set eroute [$af3qospf_agent_ get-explicit-route $dest $bw]
    } elseif {$traffic=="AF4"} {
    set eroute [$af4qospf_agent_ get-explicit-route $dest $bw]
    } else {
    set eroute [$beqospf_agent_ get-explicit-route $dest $bw]
    }
    return $eroute
}

RtModule/QOSPF instproc perd-bw-changed {} {
    $self instvar efqospf_agent_ af1qospf_agent_ af2qospf_agent_ af3qospf_agent_ af4qospf_agent_ beqospf_agent_
    #puts "in RtModule/QOSPF instproc bw-changed"

    $efqospf_agent_ bw-changed
    $af1qospf_agent_ bw-changed
    $af2qospf_agent_ bw-changed
    $af3qospf_agent_ bw-changed
    $af4qospf_agent_ bw-changed
    $beqospf_agent_ bw-changed
}


